from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n
                                                                                                                                                 
import time
                                                                                                                                                 
class RDGClock(Sensor):
    def __init__(self, time="%h:%m%a"):
        global _; _ = i18n.Translator("rdg-clock-sensor")
        Sensor.__init__(self)
        self._set_config_type("timefmt", TYPE_STRING, time)
        self._set_config_type("summer", TYPE_BOOL, 0)
        self._set_config_type("font", TYPE_STRING, "Sans 10")
        self._set_config_type("fontcolor", TYPE_STRING, "#FFFFFF")
                                                                                                                             
        self._add_timer(0, self.tick_tock)
        self._watch_config( self.watch_config )
                                                                                                                                                 
    def get_configurator(self):
        configurator = self._new_configurator()
        configurator.set_name(_("Clock"))
        configurator.add_title(_("Clock Settings"))
        configurator.add_entry(_("Time:"), "timefmt", _("Time Formatting:\n%h\tHour on a 12 hour clock\n%H\tHour on a 24 hour clock\n%m\tMinutes\n%s\tSeconds\n%a\tam/pm\n%A\tAM/PM"))
        configurator.add_checkbox(_("Summer Time"), "summer", _("Do we need to adjust for summertime or not"))
        configurator.add_font_selector(_("Font :"),"font", _("Font used in the clock"))
        configurator.add_color_selector(_("Font color :"),"fontcolor",_("Color used in the clock"))
        return configurator
                                                                                                                             
    def draw(self):
        current_time = time.gmtime(time.time())
 
        hour   = current_time[3]
        minute = current_time[4]
        second = current_time[5]
         
        if (self._get_config("summer")):
            hour = hour + 1
      
        data = self._new_output()
        time_ = self.__format_time( hour, minute, second)
        data.set("time", time_ )
        data.set("cf", self._get_config("font"))
        data.set("cfc", self._get_config("fontcolor"))
        self._send_output(data)
 
    def __format_time(self, hour, minute, second):
        h = "%(hour)02d" % vars()
        m = "%(minute)02d" % vars()
        s = "%(second)02d" % vars()
        if hour < 12 :
            a = "am"
            A = "AM"
        else:
            a = "pm"
            A = "PM"
            hour = hour - 12
        if hour == 0:
            hour = 12
        return self._get_config("timefmt").replace("%H",h).replace("%h",str( hour )).replace("%m",m).replace("%s",s).replace("%a",a).replace("%A",A)
 
    def tick_tock(self):
        self.draw()
        self._add_timer(1000, self.tick_tock)
 
    def watch_config(self,key,value):
        self.draw()
     
def new_sensor(args): return apply(RDGClock, args)
